/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-C16-3		  **/
/**                                                                       **/
/**                             Version 2.B.                              **/
/**                                                                       **/
/**             Last change      : 11.03.1998 				  **/
/**		Now usable for all micro_slots, micro_slot is parameter   **/
/**		also with indirect accessing of registers 		  **/
/**                                                                       **/
/**             Last change      : 29.08.1997 				  **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**                                                                       **/
/**                         Author : H.K.                                 **/
/**                         Status : O.K.   			          **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.	          **/
/**                                                                       **/
/** No parameters are checked.						  **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1997                           **/
/**                                                                       **/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
	(*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
	to be included.
*/

#include "m047_lib.h"

#define loword(l)           ((ushort)(l))
#define hiword(l)           ((ushort)((ulong)(l) >> 16))

/* Static Arrays */

STATIC ushort m047_reg_rsr_direct[ANZ_MOD];
STATIC ushort m047_reg_idr_direct[ANZ_MOD];
STATIC byte m047_reg_isr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC byte m047_reg_icr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC byte m047_reg_omr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC byte m047_reg_ccr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC byte m047_reg_ivr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC byte m047_reg_odr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC ushort m047_reg_irr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC ushort m047_reg_ilr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC ushort m047_reg_imr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC ushort m047_reg_ier[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC ushort m047_reg_iir[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC ushort m047_reg_ipr[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};
STATIC ushort m047_reg_ior[ANZ_MOD] = {0,0,0,0,0,0,0,0,0};

STATIC byte m047_reg_csr[ANZ_MOD] [3] = {{0,0,0},{0,0,0},{0,0,0},
				  {0,0,0},{0,0,0},{0,0,0},
				  {0,0,0},{0,0,0},{0,0,0}};
STATIC byte m047_reg_crr[ANZ_MOD] [3] = {{0,0,0},{0,0,0},{0,0,0},
				  {0,0,0},{0,0,0},{0,0,0},
				  {0,0,0},{0,0,0},{0,0,0}};
STATIC ushort m047_reg_cpr[ANZ_MOD] [3] = {{0,0,0},{0,0,0},{0,0,0},
				    {0,0,0},{0,0,0},{0,0,0},
				    {0,0,0},{0,0,0},{0,0,0}};
STATIC ushort m047_reg_cir_lo[ANZ_MOD] [3] = {{0,0,0},{0,0,0},{0,0,0},
				   {0,0,0},{0,0,0},{0,0,0},
				   {0,0,0},{0,0,0},{0,0,0}};
STATIC ushort m047_reg_cir_hi[ANZ_MOD] [3] = {{0,0,0},{0,0,0},{0,0,0},
				   {0,0,0},{0,0,0},{0,0,0},
				   {0,0,0},{0,0,0},{0,0,0}};
STATIC ushort m047_reg_cdr[ANZ_MOD] [3] = {{0,0,0},{0,0,0},{0,0,0},
				    {0,0,0},{0,0,0},{0,0,0},
				    {0,0,0},{0,0,0},{0,0,0}};
STATIC ushort m047_reg_cmr[ANZ_MOD] [3] = {{0,0,0},{0,0,0},{0,0,0},
				    {0,0,0},{0,0,0},{0,0,0},
				    {0,0,0},{0,0,0},{0,0,0}};

#if defined (__DLL__) && !defined (__OS2__)/* if a module DLL shall be generated */

#include <windows.h>

HANDLE   hInst;

#pragma argsused

int far pascal LibMain(hInstance, wDataSeg, wHeapSize, lpszCmdLine)
HANDLE  hInstance;                /* Instance of DLL          */
WORD    wDataSeg;                 /* Data segment             */
WORD    wHeapSize;                /* Size of Heap  	      */
LPSTR   lpszCmdLine;              /* Pointer to command line  */

{

  hInst = hInstance;

  if (wHeapSize > 0) UnlockData(0);

  return(1);
}

#endif  /* __DLL__ */

/* 8-Bit output to indirect register of module
*/
void mlx_out_port_indirect(byte micro_slot, byte port, byte data)
{
 mlx_out_port(m047_reg_rsr_direct[micro_slot],port);
 mlx_out_port(m047_reg_idr_direct[micro_slot],data);
}

/* 16-Bit output to indirect register of module
*/
void mlx_out16_port_indirect(byte micro_slot, byte port, ushort data)
{
 mlx_out_port(m047_reg_rsr_direct[micro_slot],port);
 ml8_out16_port(m047_reg_idr_direct[micro_slot],data);
}

/* 8-Bit input to indirect register of module
*/
byte mlx_in_port_indirect(byte micro_slot, byte port)
{
 mlx_out_port(m047_reg_rsr_direct[micro_slot],port);
 return(mlx_in_port(m047_reg_idr_direct[micro_slot]));
}

/* 16-Bit input to indirect register of module
*/
ushort mlx_in16_port_indirect(byte micro_slot, byte port)
{
 mlx_out_port(m047_reg_rsr_direct[micro_slot],port);
 return(ml8_in16_port(m047_reg_idr_direct[micro_slot]));
}

/* Init library with EEPROM-values
*/
MLXAPI void EXPORT m047_bib_startup(byte micro_slot)
{
 short endm,m;
 byte k;

 if (lobyte(mlx_read_eeprom(1,0)) == 0x29)           /* Check, whether module extender is placed at slot 1 */
   endm = ANZ_MOD;                                   /* Yes: max. number of slots */
 else
   endm = 5;                                         /* 4 slots */

 for (m = 1;m < endm;m++)                            /* Check all slots */
   if ((lobyte(mlx_read_eeprom(m,0)) == 0x2F) ||     /* M-C16-3 */
      (lobyte(mlx_read_eeprom(m,0)) == 0x33)) {      /* M-C16-1 */
     m047_reg_isr[m] = 0;
     m047_reg_icr[m] = 0;
     m047_reg_omr[m] = 0;
     m047_reg_ccr[m] = 0;
     m047_reg_ivr[m] = 0;
     m047_reg_irr[m] = 0;
     m047_reg_ilr[m] = 0;
     m047_reg_imr[m] = 0;
     m047_reg_ier[m] = 0;
     m047_reg_iir[m] = 0;
     m047_reg_ipr[m] = 0;
     m047_reg_ior[m] = 0;
     m047_reg_rsr_direct[m] = micro_slot_basis[m]+M047_RSR_DIRECT;
     m047_reg_idr_direct[m] = micro_slot_basis[m]+M047_IDR_DIRECT;
     mlx_out_port_indirect(micro_slot,M047_MIR_INDIRECT,M047_MIR_RESET);
     for (k=0;k<3;k++) {
       m047_reg_csr[m] [k] = 0;
       m047_reg_crr[m] [k] = 0;
       m047_reg_cpr[m] [k] = 0;
       m047_reg_cir_lo[m] [k] = 0;
       m047_reg_cir_hi[m] [k] = 0;
       m047_reg_cdr[m] [k] = 0;
       m047_reg_cmr[m] [k] = 0;
     }
   }
   else {
   }
}


/* Configure module like EEPROM
*/
MLXAPI void EXPORT m047_set_conf_eeprom(byte micro_slot)
{
 m047_bib_startup(micro_slot);                            /* Load startup values */
}

/* Select interrupt line to base board
*/
MLXAPI void EXPORT m047_select_irq (byte micro_slot, byte irqchannel, byte irqedge)
{
 m047_reg_isr[micro_slot] = (m047_reg_isr[micro_slot] & 0xE8) + irqchannel + irqedge;
 mlx_out_port_indirect(micro_slot,M047_ISR_INDIRECT,m047_reg_isr[micro_slot]);
}

/* Get selected interrupt line to base board
*/
MLXAPI void EXPORT m047_get_selected_irq (byte micro_slot, byte *irqchannel, byte *irqedge)
{
 *irqchannel = m047_reg_isr[micro_slot] & 7;
 *irqedge = m047_reg_isr[micro_slot] & 0x10;
}

/* Mask/demask interrupt inputs
*/
MLXAPI void EXPORT m047_mask_interrupt (byte micro_slot, ushort intchannel)
{
 m047_reg_imr[micro_slot] = intchannel;
 mlx_out16_port_indirect(micro_slot,M047_IMR_INDIRECT, intchannel);
}

/* Define edge of interrupt inputs
*/
MLXAPI void EXPORT m047_set_int_edge (byte micro_slot, ushort intedge)
{
 m047_reg_ier[micro_slot] = intedge;
 mlx_out16_port_indirect(micro_slot,M047_IER_INDIRECT, intedge);
}

/* Get masked interrupt inputs and corresponding edges
*/
MLXAPI void EXPORT m047_get_interrupt (byte micro_slot, ushort *intchannel, ushort *intedge)
{
 m047_reg_imr[micro_slot] = mlx_in16_port_indirect(micro_slot,M047_IMR_INDIRECT);
 *intchannel = m047_reg_imr[micro_slot];
 *intedge = m047_reg_ier[micro_slot];
}

/* Define latch input
*/
MLXAPI void EXPORT m047_define_latch_input (byte micro_slot, byte channel, byte edge, byte enable)
{
 m047_reg_icr[micro_slot] = (channel+edge+enable) & 0x7F;
 mlx_out_port_indirect(micro_slot,M047_ICR_INDIRECT,m047_reg_icr[micro_slot] | 0x80);
}

/* Get define latch input
*/
MLXAPI void EXPORT m047_get_latch_input (byte micro_slot, byte *channel, byte *edge, byte *enable)
{
 m047_reg_icr[micro_slot] = mlx_in_port_indirect(micro_slot,M047_ICR_INDIRECT);
 *channel = m047_reg_icr[micro_slot] & 0xF;
 *edge = m047_reg_icr[micro_slot] & 0x20;
 *enable = m047_reg_icr[micro_slot] & 0x40;
}

/* Define output function
*/
MLXAPI void EXPORT m047_define_output (byte micro_slot, byte outputfunc)
{
 m047_reg_omr[micro_slot] = outputfunc & 7;
 mlx_out_port_indirect(micro_slot,M047_OMR_INDIRECT,outputfunc);
}

/* Get defined output function
*/
MLXAPI void EXPORT m047_get_outputfunc (byte micro_slot, byte *outputfunc)
{
 *outputfunc = m047_reg_omr[micro_slot] & 7;
}


/* Configure counter
*/
MLXAPI void EXPORT m047_counter_config (byte micro_slot, m047_config_struct *config)
{
byte i,endindex;		/* For-Loop-Counter */
/*
 Define Counter Mode
*/
 endindex = config->IndexLast;

 if ((config->Mode & M047_MULTIPLE_PERIOD) == M047_MULTIPLE_PERIOD) {
   if ((config->Mode & M047_CASCADE_0_1) == M047_CASCADE_0_1) {
     endindex = config->IndexFirst;
     m047_reg_cmr[micro_slot] [0] = config->Mode-
                                    M047_MULTIPLE_PERIOD-
                                    M047_CASCADE_0_1+
                                    M047_PERIOD;
     mlx_out16_port_indirect(micro_slot,M047_CMR0_INDIRECT,
			   m047_reg_cmr[micro_slot] [0]);

     m047_reg_cir_hi[micro_slot] [0] = ((config->CounterInput & 0xF000)
				    - (ushort)(M047_CNT_0_CNT_2)) >> 9;
     m047_reg_cir_lo[micro_slot] [0] |= M047_STOP_UFL_CNT_2 >> 2;


     m047_reg_cmr[micro_slot] [1] = M047_CASCADE;
     mlx_out16_port_indirect(micro_slot,M047_CMR1_INDIRECT,
			   m047_reg_cmr[micro_slot] [1]);

     m047_reg_cmr[micro_slot] [2] = M047_COUNTER_DN+M047_COUNTER;
     mlx_out16_port_indirect(micro_slot,M047_CMR2_INDIRECT,
			   m047_reg_cmr[micro_slot] [2]);
     m047_reg_cpr[micro_slot] [2] = config->Multiple;
     ml8_out16_port(MBASIS+M047_CPR2_DIRECT,
			   m047_reg_cpr[micro_slot] [2]);
     m047_reg_cir_hi[micro_slot] [2] = (M047_CNT_0_CNT_2 - 0x8000) >> 9;
   }
   else {
     if ((config->Mode & M047_CASCADE_1_2) == M047_CASCADE_1_2) {
       endindex = config->IndexFirst;
       m047_reg_cmr[micro_slot] [0] = M047_PERIOD;
       mlx_out16_port_indirect(micro_slot,M047_CMR0_INDIRECT,
			   m047_reg_cmr[micro_slot] [0]);
       m047_reg_cir_hi[micro_slot] [0] = ((config->CounterInput & 0xF000)
				      - M047_CNT_0_CNT_1) >> 9;

       m047_reg_cir_lo[micro_slot] [0] |= M047_STOP_UFL_CNT_1 >> 2;
       m047_reg_cmr[micro_slot] [1] = M047_COUNTER_DN+M047_COUNTER;
       mlx_out16_port_indirect(micro_slot,M047_CMR1_INDIRECT,
			     m047_reg_cmr[micro_slot] [1]);
       m047_reg_cpr[micro_slot] [1] = config->Multiple;
       ml8_out16_port(MBASIS+M047_CPR1_DIRECT,
			   m047_reg_cpr[micro_slot] [1]);

       m047_reg_cir_hi[micro_slot] [1] = (M047_CNT_0_CNT_1 - 0x6000) >> 9;
       m047_reg_cmr[micro_slot] [2] = M047_CASCADE;
       mlx_out16_port_indirect(micro_slot,M047_CMR2_INDIRECT,
			     m047_reg_cmr[micro_slot] [2]);
     }
     else {
       m047_reg_cmr[micro_slot] [0] = M047_PERIOD;
       mlx_out16_port_indirect(micro_slot,M047_CMR0_INDIRECT,
			   m047_reg_cmr[micro_slot] [0]);
       m047_reg_cir_hi[micro_slot] [0] = ((config->CounterInput & 0xF000)
				    - M047_CNT_0_CNT_1) >> 9;
       m047_reg_cir_lo[micro_slot] [0] |= M047_STOP_UFL_CNT_1 >> 2;

       m047_reg_cmr[micro_slot] [1] = M047_COUNTER_DN+M047_COUNTER;
       mlx_out16_port_indirect(micro_slot,M047_CMR1_INDIRECT,
			     m047_reg_cmr[micro_slot] [1]);
       m047_reg_cpr[micro_slot] [1] = config->Multiple;
       ml8_out16_port(MBASIS+M047_CPR1_DIRECT,
			     m047_reg_cpr[micro_slot] [1]);
       m047_reg_cir_hi[micro_slot] [1] = (M047_CNT_0_CNT_1 - 0x6000) >> 9;
     }
   }
 }
 else {
   if ((config->Mode & M047_CASCADE_0_1) == M047_CASCADE_0_1) {
     endindex = config->IndexFirst;
     m047_reg_cmr[micro_slot] [0] = config->Mode & 0xFFF;
     mlx_out16_port_indirect(micro_slot,M047_CMR0_INDIRECT,
			   m047_reg_cmr[micro_slot] [0]);
     m047_reg_cmr[micro_slot] [1] = M047_CASCADE;
     mlx_out16_port_indirect(micro_slot,M047_CMR1_INDIRECT,
			   m047_reg_cmr[micro_slot] [1]);
   }
   else {
     if ((config->Mode & M047_CASCADE_1_2) == M047_CASCADE_1_2) {
       endindex = config->IndexFirst;
       m047_reg_cmr[micro_slot] [1] = config->Mode & 0x1FFF;
       mlx_out16_port_indirect(micro_slot,M047_CMR1_INDIRECT,
			     m047_reg_cmr[micro_slot] [1]);
       m047_reg_cmr[micro_slot] [2] = M047_CASCADE;
       mlx_out16_port_indirect(micro_slot,M047_CMR2_INDIRECT,
			     m047_reg_cmr[micro_slot] [2]);
     }
     else {
       if ((config->Mode & M047_CASCADE_0_1_2) == M047_CASCADE_0_1_2) {
	 endindex = config->IndexFirst;
	 m047_reg_cmr[micro_slot] [0] = config->Mode & 0x1FFF;
	 mlx_out16_port_indirect(micro_slot,M047_CMR0_INDIRECT,
			       m047_reg_cmr[micro_slot] [0]);
	 m047_reg_cmr[micro_slot] [1] = M047_CASCADE;
	 mlx_out16_port_indirect(micro_slot,M047_CMR1_INDIRECT,
			       m047_reg_cmr[micro_slot] [1]);
	 m047_reg_cmr[micro_slot] [2] = M047_CASCADE;
	 mlx_out16_port_indirect(micro_slot,M047_CMR2_INDIRECT,
			       m047_reg_cmr[micro_slot] [2]);
       }
       else {
	 if ((config->Mode & M047_INCREMENT_B)== M047_INCREMENT_B) {
	   m047_reg_cmr[micro_slot] [config->IndexFirst] = M047_INCREMENT_B;
	   mlx_out16_port_indirect(micro_slot,M047_CMR0_INDIRECT,
				 m047_reg_cmr[micro_slot] [config->IndexFirst]);
	   m047_reg_cmr[micro_slot] [config->IndexFirst+1] = M047_INCREMENT_B+1;
	   mlx_out16_port_indirect(micro_slot,M047_CMR1_INDIRECT,
				 m047_reg_cmr[micro_slot] [config->IndexFirst+1]);
	   if (config->IndexFirst == 0)
	     m047_reg_cir_hi[micro_slot] [1] = (M047_DIN_6_CNT_1 - 0x6000) >> 9;
	   else {
	     m047_reg_cir_hi[micro_slot] [1] = (M047_DIN_6_CNT_1 - 0x6000) >> 9;
	     m047_reg_cir_hi[micro_slot] [2] = (M047_DIN_4_CNT_2 - 0x8000) >> 9;
	   }
	 }
	 else {
	   for (i=config->IndexFirst;i<=config->IndexLast;i++) {
	     m047_reg_cmr[micro_slot] [i] = config->Mode & 0x1FFF;
	     mlx_out16_port_indirect(micro_slot,M047_CMR0_INDIRECT+i,
				   m047_reg_cmr[micro_slot] [i]);
	   }
	 }
       }

     }
   }
 }
/*
 Define Counter Input
*/

 if ((config->Mode & M047_MULTIPLE_PERIOD) != M047_MULTIPLE_PERIOD) {
   for (i=config->IndexFirst;i<=endindex;i++) {
     if (i == 0) {
       m047_reg_cir_hi[micro_slot] [i] = (config->CounterInput & 0x7000) >> 9;
     }
     else {
       if ((i == 1) && ((config->Mode & M047_INCREMENT_B) != M047_INCREMENT_B)) {
	 m047_reg_cir_hi[micro_slot] [i] = ((config->CounterInput & 0x7000)-0x6000) >> 9;
       }
       else {
	 if ((i == 2) && ((config->Mode & M047_INCREMENT_B) != M047_INCREMENT_B)) {
	   m047_reg_cir_hi[micro_slot] [i] = ((config->CounterInput & 0x9000)-0x8000) >> 9;
	 }
       }
     }
   }
 }
 if ((config->Mode & M047_MULTIPLE_PERIOD) == M047_MULTIPLE_PERIOD)
   endindex = config->IndexFirst;
 for (i=config->IndexFirst;i<=endindex;i++) {
   if ((config->CommandInput & M047_START_DIN_2) != 0) {
     m047_reg_cir_lo[micro_slot] [i] |=
		  ((config->CommandInput & M047_START_DIN_2) >> 4);
   }
   if ((config->CommandInput & M047_STOP_DIN_3) != 0) {
     m047_reg_cir_lo[micro_slot] [i] |=
		  ((config->CommandInput & M047_STOP_DIN_3) >> 3);
   }
   if ((config->CommandInput & M047_STOP_UFL_CNT_2) != 0) {
     m047_reg_cir_lo[micro_slot] [i] |=
		  ((config->CommandInput & M047_STOP_UFL_CNT_2) >> 2);
   }
   if ((config->CommandInput & M047_LOAD_DIN_2) != 0) {
     m047_reg_cir_lo[micro_slot] [i] |=
		  ((config->CommandInput & M047_LOAD_DIN_2) >> 1);
   }
   if ((config->CommandInput & M047_FREEZE_DIN_3) != 0) {
     m047_reg_cir_lo[micro_slot] [i] |=
		  ((config->CommandInput & M047_FREEZE_DIN_3));
   }
   if ((config->CommandInput & M047_RESET_DIN_2) != 0) {
     m047_reg_cir_hi[micro_slot] [i] |=
		  (ushort)(config->CommandInput & M047_RESET_DIN_2) >> 14;
   }
   mlx_out16_port_indirect(micro_slot,M047_CIR0_LOW_INDIRECT+i,
			 m047_reg_cir_lo[micro_slot] [i]);
   mlx_out16_port_indirect(micro_slot,M047_CIR0_HIGH_INDIRECT+i,
			 m047_reg_cir_hi[micro_slot] [i]);
 }
/*
 Define Input polarity
*/
 m047_reg_iir[micro_slot] |= config->CounterInput & 0xFFF;
 mlx_out16_port_indirect(micro_slot,M047_IIR_INDIRECT,m047_reg_iir[micro_slot]);
/*
 Define CounterOutput
*/
 m047_reg_omr[micro_slot] |= config->CounterOutput;
 mlx_out_port_indirect(micro_slot,M047_OMR_INDIRECT,m047_reg_omr[micro_slot]);
/*
 Define Interrupt Mode
*/
 if ((config->Mode & M047_VELOCITY) == M047_VELOCITY) {
   if ((config->Interrupt & M047_INT_CNT_0_END) == M047_INT_CNT_0_END) {
     m047_reg_imr[micro_slot] |= 0x4000; // INT-14
   }
   if ((config->Interrupt & M047_INT_CNT_0_INVALID) == M047_INT_CNT_0_INVALID) {
     m047_reg_imr[micro_slot] |= 0x8000; // INT-15
   }
 }
 else {
   if ((config->Interrupt & M047_INT_CNT_0_END) == M047_INT_CNT_0_END) {
     m047_reg_imr[micro_slot] |= 0x2000; // INT-13
   }
 }
 if ((config->Interrupt & M047_INT_CNT_0_UFL) == M047_INT_CNT_0_UFL) {
   m047_reg_imr[micro_slot] |= 0x2000; // INT-13
   }
 if ((config->Interrupt & M047_INT_CNT_0_OVL) == M047_INT_CNT_0_OVL) {
   m047_reg_imr[micro_slot] |= 0x1000; // INT-12
   }
 if ((config->Interrupt & M047_INT_CNT_1_UFL) == M047_INT_CNT_1_UFL) {
   m047_reg_imr[micro_slot] |= 0x80;   // INT-7
   m047_reg_isr[micro_slot] |= 0x40;
   }
 if ((config->Interrupt & M047_INT_CNT_1_OVL) == M047_INT_CNT_1_OVL) {
   m047_reg_imr[micro_slot] |= 0x40;   // INT-6
   m047_reg_isr[micro_slot] |= 0x40;
   }
 if ((config->Interrupt & M047_INT_CNT_1_END) == M047_INT_CNT_1_END) {
   m047_reg_imr[micro_slot] |= 0x80;   // INT-7
   m047_reg_isr[micro_slot] |= 0x40;
   }
 if ((config->Interrupt & M047_INT_CNT_2_UFL) == M047_INT_CNT_2_UFL) {
   m047_reg_imr[micro_slot] |= 0x20;   // INT-5
   m047_reg_isr[micro_slot] |= 0x20;
   }
 if ((config->Interrupt & M047_INT_CNT_2_OVL) == M047_INT_CNT_2_OVL) {
   m047_reg_imr[micro_slot] |= 0x10;   // INT-4
   m047_reg_isr[micro_slot] |= 0x20;
   }
 if ((config->Interrupt & M047_INT_CNT_2_END) == M047_INT_CNT_2_END) {
   m047_reg_imr[micro_slot] |= 0x20;   // INT-5
   m047_reg_isr[micro_slot] |= 0x20;
   }
 mlx_out16_port_indirect(micro_slot,M047_IMR_INDIRECT,m047_reg_imr[micro_slot]);
 mlx_out_port_indirect(micro_slot,M047_ISR_INDIRECT,m047_reg_isr[micro_slot]);
/*
 Define Reference
*/
 for (i=config->IndexFirst;i<=endindex;i++) {
   m047_reg_crr[micro_slot] [i] = config->Time;
   mlx_out_port_indirect(micro_slot,M047_CRR0_INDIRECT+i,
		       m047_reg_crr[micro_slot] [i]);
 }
}

/* Send command to counter
*/
MLXAPI void EXPORT m047_send_command (byte micro_slot, ushort command, byte counter)
{
 m047_reg_ccr[micro_slot] = command+(counter*32);
 mlx_out_port(MBASIS+M047_CCR_DIRECT,m047_reg_ccr[micro_slot]);
}

/* Write word to counter
*/
MLXAPI void EXPORT m047_preset_counter_word (byte micro_slot, byte counter, ushort data)
{
 m047_reg_cpr[micro_slot] [counter] = data;
 ml8_out16_port(MBASIS+M047_CPR0_DIRECT+(counter*4),data);
}

/* Write dword to counter
*/
MLXAPI void EXPORT m047_preset_counter_dword (byte micro_slot, byte counter, ulong data)
{
 m047_reg_cpr[micro_slot] [counter] = loword(data);
 ml8_out16_port(MBASIS+M047_CPR0_DIRECT+(counter*4),loword(data));
 m047_reg_cpr[micro_slot] [counter+1] = hiword(data);
 ml8_out16_port(MBASIS+M047_CPR0_DIRECT+((counter+1)*4),hiword(data));
}

/* Write block to counter
*/
MLXAPI void EXPORT m047_preset_counter_block (byte micro_slot, byte counter, m047_block data)
{
 m047_reg_cpr[micro_slot] [counter] = data[0];
 ml8_out16_port(MBASIS+M047_CPR0_DIRECT+(counter*4),data[0]);
 m047_reg_cpr[micro_slot] [counter+1] = data[1];
 ml8_out16_port(MBASIS+M047_CPR0_DIRECT+((counter+1)*4),data[1]);
 m047_reg_cpr[micro_slot] [counter+2] = data[2];
 ml8_out16_port(MBASIS+M047_CPR0_DIRECT+((counter+2)*4),data[2]);
}

/* Read word from counter
*/
MLXAPI ushort EXPORT m047_read_counter_word (byte micro_slot, byte counter)
{
 m047_reg_cdr[micro_slot] [counter]
     = ml8_in16_port(MBASIS+M047_CDR0_DIRECT+(counter*4));
 return(m047_reg_cdr[micro_slot] [counter]);
}

/* Read double word from counter
*/
MLXAPI ulong EXPORT m047_read_counter_dword (byte micro_slot, byte counter)
{
 m047_reg_cdr[micro_slot] [counter]
     = ml8_in16_port(MBASIS+M047_CDR0_DIRECT+(counter*4));
 m047_reg_cdr[micro_slot] [counter+1]
     = ml8_in16_port(MBASIS+M047_CDR0_DIRECT+((counter+1)*4));
 return((ulong)(m047_reg_cdr[micro_slot] [counter]) +
	(ulong)(m047_reg_cdr[micro_slot] [counter+1]) * 65536L);
}

/* Read block from counter
*/
MLXAPI void EXPORT m047_read_counter_block (byte micro_slot, byte counter, m047_block data)
{
 m047_reg_cdr[micro_slot] [counter]
     = ml8_in16_port(MBASIS+M047_CDR0_DIRECT+(counter*4));
 m047_reg_cdr[micro_slot] [counter+1]
     = ml8_in16_port(MBASIS+M047_CDR0_DIRECT+((counter+1)*4));
 m047_reg_cdr[micro_slot] [counter+2]
     = ml8_in16_port(MBASIS+M047_CDR0_DIRECT+((counter+2)*4));
 data[0] = m047_reg_cdr[micro_slot] [counter];
 data[1] = m047_reg_cdr[micro_slot] [counter+1];
 data[2] = m047_reg_cdr[micro_slot] [counter+2];
}

/* Read status of counter
*/
MLXAPI byte EXPORT m047_read_counter_status (byte micro_slot, byte counter)
{
 m047_reg_csr[micro_slot][counter] =
	mlx_in_port_indirect(micro_slot,M047_CSR0_INDIRECT+(counter*1));
 return(m047_reg_csr[micro_slot][counter]);
}

/* Read digital inputs
*/
MLXAPI ushort EXPORT m047_read_digital_input (byte micro_slot)
{
 m047_reg_irr[micro_slot] =
	ml8_in16_port(MBASIS+M047_IRR_DIRECT) & 0x0FFF;
 return(m047_reg_irr[micro_slot]);
}

/* Read digital inputs from latch
*/
MLXAPI ushort EXPORT m047_read_digital_input_latched (byte micro_slot)
{
 m047_reg_ilr[micro_slot] =
	mlx_in16_port_indirect(micro_slot,M047_ILR_INDIRECT) & 0x0FFF;
 return(m047_reg_ilr[micro_slot]);
}

/* Latch digital inputs
*/
MLXAPI void EXPORT m047_latch_digital_input (byte micro_slot)
{
 mlx_out_port_indirect(micro_slot,M047_ICR_INDIRECT,m047_reg_icr[micro_slot] & 0x7F);
}

/* Set digital outputs
*/
MLXAPI void EXPORT m047_set_digital_output (byte micro_slot, byte data)
{
 m047_reg_odr[micro_slot] = data;
 mlx_out_port(MBASIS+M047_ODR_DIRECT,m047_reg_odr[micro_slot] & 0xF);
}

/* Read interrupt-vector-register
*/
MLXAPI void EXPORT m047_read_ivr (byte micro_slot, byte *intnumber, byte *overrun)
{
 m047_reg_ivr[micro_slot] = mlx_in_port(MBASIS+M047_IVR_DIRECT);
 *intnumber = m047_reg_ivr[micro_slot] & 0xF;
 *overrun =  (m047_reg_ivr[micro_slot] & 0x20) >> 5;
}


/* Read interrupt-pending-register
*/
MLXAPI ushort EXPORT m047_read_ipr (byte micro_slot)
{
 m047_reg_ipr[micro_slot] = mlx_in16_port_indirect(micro_slot,M047_IPR_INDIRECT);
 return(m047_reg_ipr[micro_slot]);
}

/* Read interrupt-overrun-register
*/
MLXAPI ushort EXPORT m047_read_ior (byte micro_slot)
{
 m047_reg_ior[micro_slot] = mlx_in16_port_indirect(micro_slot,M047_IOR_INDIRECT);
 return(m047_reg_ior[micro_slot]);
}
