/************************************************************************
*
*                         MODULE.H
*
*        general header for SORCUS modules, this file is included
*        by all modul headers Mxxx_LIB.H
*
*                     version      : see history
*                     creation     : 03.12.96
*                     last change  : see history
*                     authors      : HK, MIH
*
*       (c) by SORCUS Computer GmbH Heidelberg 1996
*************************************************************************/

/************************************************************************
*
*  description:
*       This header files makes definitions which are used by
*       the several module header files (Mxxx_LIB.H).
*       The file can be used on different platforms:
*               MS-DOS
*               Windows 3.1
*               Windows 95
*               Windows NT
*               OS/2
*       It is tested with various compilers:
*               Borland C
*               Borland Pascal
*               Microsoft C
*
*  hints:
*     - If there are questions or problems with this file please
*       have a look on README.TXT before contacting SORCUS Computer.
*
*     - In the README.DOC there is also an explanation about the
*       various branches in this file.
*
*************************************************************************/

/************************************************************************
*  history:
*      1.A. 03.12.96 (HK/MIH):
*        - creation of the file
*      1.B. 22.08.97 (HK)
*	 - ulong defined
*************************************************************************/

#if !defined _MLXMODUL_
#define _MLXMODUL_

#if defined(ML8RT)
   #if !defined(byte)
      #define byte        unsigned char
   #endif
   #if !defined(ushort)
      #define ushort      unsigned short
   #endif
   #if !defined(ulong)
      #define ulong	  unsigned long
   #endif

   #define EXPORT    far pascal
   #define MLXAPI
   #define ANZ_MOD 11                  /* MODULAR-4/486: number of module
                                          slots: 10+1 (slot 0 is not used) */
   #if defined(BORLAND_PASCAL)
      #define STATIC static            /* Definition of arrays */
   #else
      #define STATIC static far
   #endif

   #include "stdio.h"
   #include "dos.h"
   #include "ML8RTBIB.H"

   #define mlx_read_eeprom(micro_slot,offset) ml8rt_read_eeprom_copy(micro_slot,offset)
   #define mlx_out_port(port,dat1)   outportb(port,dat1)
   #define ml8_out16_port(port,dat1) outport(port,dat1)
   #define mlx_in_port(port)         inportb(port)
   #define ml8_in16_port(port)       inport(port)

   const STATIC ushort micro_slot_basis[ANZ_MOD] = {0,0x400,0x500,0x600,
			       0x700,0x420,0x440,0x460,0x480,0x4A0,0x4C0};

#elif defined(ML8)
   #define ANZ_MOD 11                  /* MODULAR-4/486: number of module
					  slots: 10+1 (slot 0 is not used) */
   #if defined (__OS2__)
      #define STATIC static
      #define MLXAPI
   #elif defined (WIN32)
      #define STATIC static
      #include "windows.h"
   #else
      #if defined(BORLAND_PASCAL)
	 #define STATIC static
      #else
	 #define STATIC static far
      #endif
      #define MLXAPI
   #endif

   #include "ML8BIB.H"

   /* The functions of library ML8BIB all begin with ml8_... : */
   #define mlx_read_eeprom           ml8_read_eeprom_copy
   #define mlx_out_port              ml8_out8_port
   #define mlx_in_port               ml8_in8_port

   const STATIC ushort micro_slot_basis[ANZ_MOD] = {0,0x400,0x500,0x600,
			       0x700,0x420,0x440,0x460,0x480,0x4A0,0x4C0};

#else                                  /* ML4/5 (MODULAR-4/Zxx) */
   #if !defined(byte)
      #define byte        unsigned char
   #endif

   #if !defined(ushort)
      #define ushort      unsigned short
   #endif

   #define EXPORT    far pascal
   #define MLXAPI
   #define ANZ_MOD 5                   /* MODULAR-4/Zxx: number of module
					  slots 4+1 (slot 0 is not used) */
   #if defined(BORLAND_PASCAL)
      #define STATIC static
      extern void pascal ml4_out_port(ushort port, byte data);
      extern byte pascal ml4_in_port(ushort port);
      extern ushort pascal ml4_read_eeprom(byte micro_slot, byte offset);
   #else
      #define STATIC static far        /* Definition of arrays */
      #if defined(_Windows)
	 #include "WML4BIB.H"
	 #include "WML4DEB.H"
      #else
	 #include "ML4BIB.H"
	 #include "ML4DEB.H"
      #endif
   #endif

   /* The functions of library ML4BIB/ML4DEB all begin with ml4_... : */
   #define mlx_read_eeprom                  ml4_read_eeprom
   #define mlx_out_port                     ml4_out_port
   #define mlx_in_port                      ml4_in_port

   const STATIC byte micro_slot_basis[ANZ_MOD] = {0,0x80,0xA0,0xC0,0xE0};

#endif

#define lobyte(w)           ((byte)(w))
#define hibyte(w)           ((byte)((ushort)(w) >> 8))

#endif
