/***************************************************************************/
/* Beispielprogramm C16BSP_4.C in BORLAND C++ 3.1 fr die Verwendung des   */
/* Moduls M-C16-3.                                                         */
/*                                                                         */
/* Version von C16BSP_4.C: 1.A.    Stand: 29.08.1997                       */
/*                                                                         */
/* Dieses Beispielprogramm demonstriert den Einsatz des M-C16-3 als        */
/* Frequenzmesser (Aufloesung 32 Bit, Gate = 1ms). 			   */
/***************************************************************************/

/* Fr BORLAND C++ 3.1: Standard Run-time Libraries auf static oder dynamic
	in Option/Linker/Libraries einstellen                              */

/***************************************************************************/
/******************************** INCLUDES *********************************/
/***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include "ml8bib.h"
#include "m047_lib.h"

/***************************************************************************/
/******************************** DEFINES **********************************/
/***************************************************************************/

#define BAdr      0x380		      // Basisadresse der MODULAR-4/486-Karte
#define SLOT      2                   // Steckplatz 2
#define COUNTER_0 0                   // Zaehler 0
#define COUNTER_1 1                   // Zaehler 1

/***************************************************************************/
/******************************* Prototypen ********************************/
/***************************************************************************/

void far pascal errorhandler(void);

/***************************************************************************/
/***************************** HAUPTPROGRAMM *******************************/
/***************************************************************************/

void main(void)
{

/* Variablendefinition */

char taste;     // Tastatur-Input
ushort cdr0;	// Zaehlerstand des Zaehlerkanals 0
		// (Counter-Data-Register Nr. 0)
ushort cdr1;	// Zaehlerstand des Zaehlerkanals 1
		// (Counter-Data-Register Nr. 1)
m047_config_struct configuration; // Konfigurationsstruktur

/* Programmiersprache = C */

ml8_bib_startup (LANGUAGE_C);

/* Basiskarte zurueksetzen */

ml8_reset(0, BAdr, 0, 7, 0, *errorhandler, "ROM", 10);

/* Initialisierung des M-C16-3 */

clrscr();
printf("BEISPIEL: Einsatz des M-C16-3 fuer 32-Bit-Frequenzmessung\n\n");
printf("1. Schliessen sie bitte das zu messende Signal an DIN-4 an.\n");
printf("2. Stecken Sie das M-C16-3-Modul in Slot 2.\n\n");
printf("Einstellungen: Torzeit = 1ms, Aufloesung = 32 Bit\n");

// M-C16-3 zuruecksetzen

m047_bib_startup(SLOT);

/* Einsatz des M-C16-3 zur Frequenzmessung (32 Bit) */

configuration.IndexFirst = 0;
configuration.IndexLast = 1;

// Zaehlerkanal 0 in den Mode "Frequenzmessung" und in die Submodes
// CONTINUE, AUTOFREEZE und AUTORESET versetzen

configuration.Mode = M047_FREQUENCY+
                     M047_AUTOFREEZE+
                     M047_CONTINUE+
                     M047_AUTORESET+

// Zaehlerkanal 1 kaskadieren

                     M047_CASCADE_0_1;

// Die Zaehleingaenge des Zaehlers 0 sind nach einem Reset mit DIN-8
// und DIN-9 verbunden. Hier werden die Zaehleingnge nun an DIN-4
// und DIN-5 umgeleitet.

configuration.CounterInput = M047_DIN_4_5_CNT_0;

// Kein Zaehlerausgang

configuration.CounterOutput = M047_NO_DOUT;

// Kein externer Start, Stop, Load, Freeze und Reset

configuration.CommandInput = M047_NO_START+
                             M047_NO_STOP+
                             M047_NO_STOP+
                             M047_NO_LOAD+
                             M047_NO_FREEZE+
                             M047_NO_RESET;

// Kein Interrupt

configuration.Interrupt = M047_NO_INT;

// Torzeit = 1 ms einstellen

configuration.Time = M047_1_MS;

// Keine Mehrfachmessung

configuration.Multiple = 0;

// Zaehler konfigurieren

m047_counter_config(SLOT,&configuration);

gotoxy (1,9);

printf ("1 = Messung starten\n");
printf ("2 = Messung stoppen\n");
printf ("3 = Zaehler zuruecksetzen\n");
printf ("ESC = Ende\n");

taste = '0';

do
  {
  gotoxy (1,14);
  printf ("Bitte waehlen Sie: ");

  if ( kbhit() )
	 taste = getch();

  switch (taste)
	 { case '1': // Messung starten
                     m047_send_command(SLOT,M047_CMD_START_COUNTER,M047_COUNTER_0);
		     taste = '0';
		     break;

	   case '2': // Messung stoppen
                     m047_send_command(SLOT,M047_CMD_STOP_COUNTER,M047_COUNTER_0);
		     taste = '0';
		     break;

	   case '3': // Zaehler auf 0 sezten
                     m047_send_command(SLOT,M047_CMD_RESET_COUNTER,M047_COUNTER_0);

		     // Zaehlerstand 0 in Ausgangsregister cdr0 und cdr1
		     // uebernehmen
                     m047_send_command(SLOT,M047_CMD_FREEZE_COUNTER,M047_COUNTER_0);
                     taste = '0';
		     break;

	   default : break;

	 } /* switch */


  // Bit 0 bis 15 des Ergebnisses lesen
  cdr0 = m047_read_counter_word(SLOT,COUNTER_0);
  // Bit 16 bis 32 des Ergebnisses lesen
  cdr1 = m047_read_counter_word(SLOT,COUNTER_1);

  gotoxy (1,20);
  printf ("Frequenz: %08d kHz",(cdr1*0x10000+cdr0)); 	// Ausgabe des

  } while (taste != 27);

  ml8_exit();

} /* main */


#include "error.c"
