/***************************************************************************/
/******** PROCEDURE : ERRORHANDLER                                  ********/
/***************************************************************************/

void far pascal errorhandler(void)
{
	struct ml8_error_info_type  error_info, *err_p=&error_info;
	int	i;
	char	s80[81];
	char	ch;
	ushort	w;


	ml8_get_error_info(err_p);

	if (err_p->mark==0) return;

	printf("\n\n\nBenutzer-eigene Fehlerbehandlung\n\n");

	if (err_p->ok)
	{
		printf("Die Fehlerbehandlung wurde grundlos aufgerufen\n");
		printf("(mglicherweise direkt vom C-Programm, statt von der Bibliothek)\n");
		getch();
		return;
	}
	if (err_p->errorclass==5)
	{
	  w=ml8_get_message();

	  printf("Die Fehlermeldung wurde durch einen Errorrequest\n");
	  printf("von der MODULAR-4 Karte ausgelst\n\n");
	  printf("Fehler-Request von Karte: ");
	  printf("     SRQ: %X>H\n",w);
	  printf("Bitte eine Taste drcken ");

	  while (!kbhit()) ;
	  return;
	}
	printf("\n");
	if (err_p->statusmap & 128 > 0)
	{
	  printf("Kommunikationsversuch ohne Initialisierung der \n");
	  printf("Bibliothek fr die angewhlte Karte\n");
	  printf("Verwenden Sie ml8_start oder ml4_reset\n");
	  printf("Programm angehalten\n");
	  abort();
	}
	if (err_p->statusmap & 1 > 0)
	{
	  printf("Kommunikationsversuch ohne ausreichende Fehlerbehandlung.\n");
	  printf("Verwenden Sie ml8_clear_error in der Fehlerbehandlungsroutine\n");
	  printf("Die Fehlervariablen enthalten noch den ursprnglichen Fehler.\n\n");
	}
	ml8_get_error_message(s80);
	printf("Fehlernachricht: %s\n",s80);
	printf("Fehlerklasse %d     ",err_p->errorclass);
	printf("Fehler-Code %d\n",err_p->errorcode);
	printf("Fehler aufgetreten bei Ausfhrung von Makro-Befehl %XH\n",err_p->outwords[0]);
	printf("Schnittstellenstatus (Basisadresse) %XH\n",err_p->statusport);

	printf("\nFehler aufgetreten nach Markierung %d\n",err_p->mark);
	ml8_get_mark_message(s80);
	printf("Mark-Nachricht: %s\n",s80);

	printf("\nProgramm weiterfhren <RETURN> oder Abbruch <A/a> ? ");

	ch='x';
	while (strchr("Aa'\r'", ch)==0) ch=getch();
	if (strchr("Aa", ch)>0)
	{
		printf("\nProgramm wird angehalten\n");
		ml8_exit();
		abort();
	}
	else
	{
		printf("\nProgramm wird weitergefhrt\n");
		ml8_clear_error();
		ml8_get_error_message(s80);
		if (strcmp(s80, "")!=0)
		{	printf("ml8_clear_error() lscht die error_message nicht\n");
		}
		w=ml8_clear();
		if (w>0)
		{
		printf("\nml8_clear ist erfolglos. Programm wird angehalten\n");
		ml8_exit();
		abort();
		}
	}
}
