{$C MOVEABLE DEMANDLOAD DISCARDABLE}
(***************************************************************************)
(**                                                                       **)
(**              MODULAR-4 library for SPB module M-C16-3                 **)
(**                                                                       **)
(**                             Version 2.B.                              **)
(**                                                                       **)
(**             Last change      : 11.03.1998 				  **)
(**             Now usable for all micro_slots, micro_slot in now         **)
(**             parameter using the indirect registers                    **)
(**                                                                       **)
(**             Last change      : 29.08.1997 				  **)
(**                                                                       **)
(**  This file contains routines for Borland Pascal to allow the user,    **)
(**  to write programs for the MODULAR-4 in "PASCAL" 			  **)
(**                                                                       **)
(**                         Author : H.K.                                 **)
(**                         Status : O.K.                                 **)
(**                                                                       **)
(**                                                                       **)
(** Special comments: 							  **)
(**                                                                       **)
(** This library was tested with Borland Pascal Version 7.0.	          **)
(**                                                                       **)
(** No parameters are checked.						  **)
(**                                                                       **)
(**                                                                       **)
(**                                                                       **)
(**               (c) SORCUS Computer GmbH 1997                           **)
(**                                                                       **)
(***************************************************************************)

(* The switches for the library are set in the configuration files of Pascal
   (*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
	to be included.
*)
unit m047_lib;
interface
uses
{$IFDEF ML8}
        {$IFDEF Windows}
                wml8bib;        (* Include library for MODULAR-4/486 under Windows *)
        {$ELSE}
               {$IFDEF ML8RT}
                       ml8rtbib;    (* Include library for MODULAR-4/486 realtime programs *)
               {$ELSE}
                       ml8bib;      (* Include library for MODULAR-4/486 under DOS *)
               {$ENDIF}
        {$ENDIF}
{$ELSE}
        {$IFDEF Windows}
                wml4bib,wml4deb;    (* Include library for MODULAR-4/Z80 under WINDOWS *)
        {$ELSE}
                ml4bib,ml4deb;      (* Include library for MODULAR-4/Z80 under DOS *)
        {$ENDIF}
{$ENDIF}

CONST
     M047_MIR_RESET     =  $80;	 (* Modul-Reset                         *)

     M047_NO_IRQ        = 0;	 (* No interrupt line selected          *)
     M047_IRQ_A		= 1;     (* Interrupt line IRQ-A selected       *)
     M047_IRQ_B		= 2;     (* Interrupt line IRQ-B selected       *)
     M047_IRQ_C		= 3;     (* Interrupt line IRQ-C selected       *)
     M047_IRQ_D		= 4;     (* Interrupt line IRQ-D selected       *)
     M047_IRQ_E		= 5;     (* Interrupt line IRQ-E selected       *)
     M047_IRQ_F		= 6;     (* Interrupt line IRQ-F selected       *)
     M047_IRQ_NMI	= 7;     (* Interrupt line NMI selected         *)
     M047_IRQ_POS_EDGE	= 0;	 (* Positive edge releases interrupt    *)
     M047_IRQ_NEG_EDGE	= 16;	 (* Negative edge releases interrupt    *)

     M047_DEMASK_INT_0   = 1;       (* Demask interrupt line INT-0      *)
     M047_DEMASK_INT_1   = 2;       (* Demask interrupt line INT-1      *)
     M047_DEMASK_INT_2   = 4;       (* Demask interrupt line INT-2      *)
     M047_DEMASK_INT_3   = 8;       (* Demask interrupt line INT-3      *)
     M047_DEMASK_INT_4   = 16;      (* Demask interrupt line INT-4      *)
     M047_DEMASK_INT_5   = 32;      (* Demask interrupt line INT-5      *)
     M047_DEMASK_INT_6   = 64;      (* Demask interrupt line INT-6      *)
     M047_DEMASK_INT_7   = 128;     (* Demask interrupt line INT-7      *)
     M047_DEMASK_INT_8   = 256;     (* Demask interrupt line INT-8      *)
     M047_DEMASK_INT_9   = 512;     (* Demask interrupt line INT-9      *)
     M047_DEMASK_INT_10  = 1024;    (* Demask interrupt line INT-10     *)
     M047_DEMASK_INT_11  = 2048;    (* Demask interrupt line INT-11     *)
     M047_DEMASK_INT_12  = 4096;    (* Demask interrupt line INT-12     *)
     M047_DEMASK_INT_13  = 8192;    (* Demask interrupt line INT-13     *)
     M047_DEMASK_INT_14  = 16384;   (* Demask interrupt line INT-14     *)
     M047_DEMASK_INT_15  = 32768;   (* Demask interrupt line INT-15     *)

     M047_INT_0_NEG_EDGE = 1;       (* Negative edge for INT-0          *)
     M047_INT_1_NEG_EDGE = 2;       (* Negative edge for INT-1          *)
     M047_INT_2_NEG_EDGE = 4;       (* Negative edge for INT-2          *)
     M047_INT_3_NEG_EDGE = 8;       (* Negative edge for INT-3          *)
     M047_INT_4_NEG_EDGE = 16;      (* Negative edge for INT-4          *)
     M047_INT_5_NEG_EDGE = 32;      (* Negative edge for INT-5          *)
     M047_INT_6_NEG_EDGE = 64;      (* Negative edge for INT-6          *)
     M047_INT_7_NEG_EDGE = 128;     (* Negative edge for INT-7          *)
     M047_INT_8_NEG_EDGE = 256;     (* Negative edge for INT-8          *)
     M047_INT_9_NEG_EDGE = 512;     (* Negative edge for INT-9          *)
     M047_INT_10_NEG_EDGE = 1024;   (* Negative edge for INT-10         *)
     M047_INT_11_NEG_EDGE = 2048;   (* Negative edge for INT-11         *)
     M047_INT_12_NEG_EDGE = 4096;   (* Negative edge for INT-12         *)
     M047_INT_13_NEG_EDGE = 8192;   (* Negative edge for INT-13         *)
     M047_INT_14_NEG_EDGE = 16384;  (* Negative edge for INT-14         *)
     M047_INT_15_NEG_EDGE = 32768;  (* Negative edge for INT-15         *)

     M047_LATCH_POS_EDGE = 0;	 (* Positive edge for latch input       *)
     M047_LATCH_NEG_EDGE = 32;	 (* Negative edge for latch input       *)
     M047_LATCH_DISABLE	 = 0;	 (* Disable latch input                 *)
     M047_LATCH_ENABLE   = 64;	 (* Enable latch input                  *)

     M047_INACTIVE	   = 0;	 (* Counter not activated               *)
     M047_COUNTER_UP	   = 1;	 (* Up-Counter                          *)
     M047_COUNTER_DN	   = 2;  (* Down-Counter                        *)
     M047_COUNTER_UP_DN_A  = 3;	 (* Up-/Down-Counter type A             *)
     M047_COUNTER_UP_DN_B  = 4;	 (* Up-/Down-Counter type B             *)
     M047_TIMER		   = 5;	 (* Timer                               *)
     M047_INCREMENT_A	   = 6;	 (* Incremental interface type A        *)
     M047_INCREMENT_B	   = 7;	 (* Incremental interface type B        *)
     M047_FREQUENCY	   = 9;	 (* Frequency measurement               *)
     M047_PULSEWIDTH	   = 10; (* Pulsewidth measurement              *)
     M047_PERIOD	   = 11; (* Period measurement                  *)
     M047_VELOCITY	   = 12; (* Velocity measurement                *)
     M047_MULTIPLE_PERIOD  = 4096; (* Continuous period measurement     *)
     M047_COUNTER	   = 4096; (* Additional Counter                *)

     M047_AUTOSTART	   =	 32;	 (* Autostart                                   *)
     M047_CONTINUE	   =	 64;	 (* Continue (auto. reload after zero crossing) *)
     M047_EXTERN	   =	 128;	 (* Count gate from external                    *)
     M047_SINGLE_A	   =	 0;	 (* Incremental interface: Mode Single Phase A  *)
     M047_SINGLE_B	   =	 64;	 (* Incremental interface: Mode Single Phase B  *)
     M047_DOUBLE_A	   =	 128;	 (* Incremental interface: Mode Double Phase A  *)
     M047_DOUBLE_B	   =	 192;	 (* Incremental interface: Mode Double Phase B  *)
     M047_QUADRUPLE	   =	 256;	 (* Incremental interface: Mode Quadruple       *)
     M047_AUTOFREEZE	   =	 256;	 (* Auto. freeze after end of measurement       *)
     M047_AUTORESET	   =	 512;	 (* Auto. reset after end of measurement        *)
     M047_AUTOLOAD	   =	 1024;	 (* Auto. load after ende of measurement        *)
     M047_OVERRIDE	   =	 2048;	 (* Old counter value is overwritten by freeze  *)
     M047_CASCADE	   =	 32768;	 (* Cascade to previous counters                *)
     M047_CASCADE_0_1	   =     8192;	 (* Cascade of counter 0 and 1                  *)
     M047_CASCADE_1_2	   =     16384;	 (* Cascadr of counter 1 and 2                  *)
     M047_CASCADE_0_1_2	   =     32768;	 (* Cascade of counter 0, 1 and 2               *)

     M047_DIN_0_1_CNT_0	   =     0;      (* DIN-0 to count input 0 of counter 0         *)
     M047_DIN_2_3_CNT_0	   =     4096;   (* DIN-2 to count input 0 of counter 0         *)
     M047_DIN_4_5_CNT_0	   =     8192;   (* DIN-4 to count input 0 of counter 0         *)
     M047_DIN_6_7_CNT_0	   =     12288;  (* DIN-6 to count input 0 of counter 0         *)
     M047_DIN_8_9_CNT_0	   =     16384;  (* DIN-8 to count input 0 of counter 0         *)
     M047_DIN_10_11_CNT_0  =     20480;  (* DIN-10 to count input 0 of counter 0        *)
     M047_DIN_6_CNT_1	   =     24576;  (* DIN-6 to count input 0 of counter 0         *)
     M047_CNT_0_CNT_1	   =     28672;  (* Count input 0 of counter 1                  *)
					 (* to count input 1 of counter 0               *)
     M047_DIN_4_CNT_2	   =     32768;  (* DIN-4 to count input 0 of counter 0         *)
     M047_CNT_0_CNT_2	   =     36864;  (* Count input 0 of counter 2                  *)
					 (* to count input 0 of counter 0               *)

     M047_DIN_0_INV        =     1;	 (* Invert input signal at DIN-0                *)
     M047_DIN_1_INV        =	 2;	 (* Invert input signal at DIN-1                *)
     M047_DIN_2_INV	   =	 4;	 (* Invert input signal at DIN-2                *)
     M047_DIN_3_INV	   =	 8;      (* Invert input signal at DIN-3                *)
     M047_DIN_4_INV	   =	 16;	 (* Invert input signal at DIN-4                *)
     M047_DIN_5_INV	   =	 32;     (* Invert input signal at DIN-5                *)
     M047_DIN_6_INV	   =	 64;	 (* Invert input signal at DIN-6                *)
     M047_DIN_7_INV	   =	 128;    (* Invert input signal at DIN-7                *)
     M047_DIN_8_INV	   =	 256;    (* Invert input signal at DIN-8                *)
     M047_DIN_9_INV	   =	 512;    (* Invert input signal at DIN-9                *)
     M047_DIN_10_INV	   =	 1024;   (* Invert input signal at DIN-10               *)
     M047_DIN_11_INV       =	 2048;   (* Invert input signal at DIN-11               *)

     M047_NO_DOUT          =     0; 	 (* No output of counter                        *)
     M047_DOUT_0_CNT_0	   =     1; 	 (* DOUT-0 is output of counter 0               *)
     M047_DOUT_1_CNT_1	   =     2; 	 (* DOUT-1 is output of counter 1               *)
     M047_DOUT_2_CNT_2	   =     4; 	 (* DOUT-2 is output of counter 2               *)

     M047_NO_START	   =     0;	 (* Start not by external input                 *)
     M047_START_DIN_0	   =     16;	 (* Start by external input DIN-0               *)
     M047_START_DIN_1	   =     32;	 (* Start by external input DIN-1               *)
     M047_START_DIN_2	   =     48;	 (* Start by external input DIN-2               *)

     M047_NO_STOP	   =     0;	 (* Stop not by external input                  *)
     M047_STOP_DIN_1	   =     64;	 (* Stop by external input DIN-1                *)
     M047_STOP_DIN_2	   =     128;	 (* Stop by external input DIN-2                *)
     M047_STOP_DIN_3	   =     192;	 (* Stop by external input DIN-3                *)
     M047_NO_STOP_UFL	   =     0;	 (* Stop not by underflow of counter 0          *)
     M047_STOP_UFL_CNT_0   =     256;	 (* Stop by underflow of counter 0              *)
     M047_STOP_UFL_CNT_1   =     512;	 (* Stop by underflow of counter 1              *)
     M047_STOP_UFL_CNT_2   =     768;	 (* Stop by underflow of counter 2              *)

     M047_NO_LOAD	   =     0;	 (* Load not by external input                  *)
     M047_LOAD_DIN_0	   =     1024;	 (* Load by external input DIN-0                *)
     M047_LOAD_DIN_1	   =     2048;	 (* Load by external input DIN-1                *)
     M047_LOAD_DIN_2	   =     3072;	 (* Load by external input DIN-2                *)

     M047_NO_FREEZE	   =     0;	 (* Freeze not by external input                *)
     M047_FREEZE_DIN_1 	   =     4096;	 (* Freeze by external input DIN-1              *)
     M047_FREEZE_DIN_2 	   =     8192;	 (* Freeze by external input DIN-2              *)
     M047_FREEZE_DIN_3 	   =     12288;	 (* Freeze by external input DIN-3              *)

     M047_NO_RESET	   =     0;	 (* Reset not by external input                 *)
     M047_RESET_DIN_0 	   =     16384;	 (* Reset by external input DIN-0               *)
     M047_RESET_DIN_1 	   =     32768;  (* Reset by external input DIN-1               *)
     M047_RESET_DIN_2 	   =     49152;	 (* Reset by external input DIN-2               *)

     M047_NO_INT	   =     0;	 (* No interrupt                                *)
     M047_INT_CNT_0_UFL	   =     1;	 (* Release interrupt by underflow counter 0    *)
     M047_INT_CNT_0_OVL	   =     2;	 (* Release interrupt by overflow counter 0     *)
     M047_INT_CNT_0_END	   =     4;	 (* Release interrupt by end of measurement     *)
     M047_INT_CNT_0_INVALID=	 8;	 (* Release interrupt by invalid measurement    *)
     M047_INT_CNT_1_UFL	   =     16;	 (* Release interrupt by underflow counter 1    *)
     M047_INT_CNT_1_OVL	   =     32;	 (* Release interrupt by overflow counter 1     *)
     M047_INT_CNT_1_END	   =     64;	 (* Release interrupt by end of measurement     *)
     M047_INT_CNT_2_UFL	   =     128;	 (* Release interrupt by underflow counter 2    *)
     M047_INT_CNT_2_OVL	   =     256;	 (* Release interrupt by overflow counter 2     *)
     M047_INT_CNT_2_END	   =     512;	 (* Release interrupt by end of measurement     *)

     M047_NO_FREQ	   =     0;	 (* No reference frequency                      *)
     M047_10_MHZ	   =     2;	 (* Reference frequency 10 MHz                  *)
     M047_5_MHZ		   =     3;      (*                      5 MHz                  *)
     M047_2_MHZ		   =     4;      (*                      1 MHz                  *)
     M047_1_MHZ		   =     5;      (*                         :                   *)
     M047_500_KHZ	   =     6;      (*                         :                   *)
     M047_200_KHZ	   =     7;
     M047_100_KHZ	   =     8;
     M047_50_KHZ	   =     9;
     M047_20_KHZ	   =     10;
     M047_10_KHZ	   =     11;
     M047_5_KHZ		   =     12;
     M047_2_KHZ		   =     13;
     M047_1_KHZ		   =     14;
     M047_500_HZ	   =     15;
     M047_200_HZ	   =     16;
     M047_100_HZ	   =     17;
     M047_50_HZ		   =     18;
     M047_20_HZ		   =     19;
     M047_10_HZ		   =     20;

     M047_NO_PERIOD	   =     0;
     M047_100_NS	   =     2;
     M047_200_NS           =     3;
     M047_500_NS           =     4;
     M047_1_US		   =     5;
     M047_2_US             =     6;
     M047_5_US             =     7;
     M047_10_US		   =     8;
     M047_20_US            =     9;
     M047_50_US            =     10;
     M047_100_US	   =     11;
     M047_200_US           =     12;
     M047_500_US           =     13;
     M047_1_MS		   =     14;
     M047_2_MS             =     15;
     M047_5_MS             =     16;
     M047_10_MS		   =     17;
     M047_20_MS            =     18;
     M047_50_MS            =     19;
     M047_100_MS	   =     20;

     M047_NO_MULTIPLE	   =     0;	 (* No multiple measurement *)

     M047_CMD_START_COUNTER   =  1;
     M047_CMD_STOP_COUNTER    =  2;
     M047_CMD_LOAD_COUNTER    =  4;
     M047_CMD_FREEZE_COUNTER  =  8;
     M047_CMD_RESET_COUNTER   =  16;

     M047_COUNTER_0	      =  1;
     M047_COUNTER_1	      =  2;
     M047_COUNTER_2	      =  4;
     M047_COUNTER_0_1	      =  3;
     M047_COUNTER_1_2	      =  6;
     M047_COUNTER_0_2	      =  5;
     M047_COUNTER_0_1_2	      =  7;

type
    m047_block = array[0..2] of word;

    m047_config_struct = record
                               IndexFirst: word;
	                       IndexLast: word;
	                       Mode: word;
	                       CounterInput: word;
	                       CounterOutput: word;
	                       CommandInput: word;
	                       Interrupt: word;
	                       Time: word;
	                       Multiple: word;
	                       end;


{$IFDEF Windows}
const
     M047DLL = 'M047_LIB';
{$ENDIF}



(* Init module library
*)
Procedure m047_bib_startup (micro_slot: byte);

(* Config module as defined in EEPROM
*)
Procedure m047_set_conf_eeprom (micro_slot: byte);

(* Select interrupt line to base board
*)
Procedure m047_select_irq (micro_slot: byte; irqchannel: byte; irqedge: byte);

(* Get selected interrupt line to base board
*)
Procedure m047_get_selected_irq (micro_slot: byte; var irqchannel: byte; var irqedge: byte);

(* Mask/demask interrupt inputs
*)
Procedure m047_mask_interrupt (micro_slot: byte; intchannel: word);

(* Define edge of interrupt inputs
*)
Procedure m047_set_int_edge (micro_slot: byte; intedge: word);

(* Get masked interrupt inputs and corresponding edges
*)
Procedure m047_get_interrupt (micro_slot: byte; var intchannel: word; var intedge: word);

(* Define latch input
*)
Procedure m047_define_latch_input (micro_slot: byte; channel: byte; edge: byte; enable: byte);

(* Get define latch input
*)
Procedure m047_get_latch_input (micro_slot: byte; var channel: byte; var edge: byte; var enable: byte);

(* Define output function
*)
Procedure m047_define_output (micro_slot: byte; outputfunc: byte);

(* Get defined output function
*)
Procedure m047_get_outputfunc (micro_slot: byte; var outputfunc: byte);

(* Configure counter
*)
Procedure m047_counter_config (micro_slot: byte; var config: m047_config_struct);

(* Send command to counter
*)
Procedure m047_send_command (micro_slot: byte; command: word; counter: byte);

(* Write word to counter
*)
Procedure m047_preset_counter_word (micro_slot: byte; counter: byte; data: word);

(* Write dword to counter
*)
Procedure m047_preset_counter_dword (micro_slot: byte; counter: byte; data: longint);

(* Write block to counter
*)
Procedure m047_preset_counter_block (micro_slot: byte; counter: byte; data: m047_block);

(* Read word from counter
*)
Function m047_read_counter_word (micro_slot: byte; counter: byte): word;

(* Read double word from counter
*)
Function m047_read_counter_dword (micro_slot: byte; counter: byte): longint;

(* Read block from counter
*)
Procedure m047_read_counter_block (micro_slot: byte; counter: byte; var data: m047_block);

(* Read status of counter
*)
Function m047_read_counter_status (micro_slot: byte; counter: byte): byte;

(* Read digital inputs
*)
Function m047_read_digital_input (micro_slot: byte): word;

(* Read digital inputs from latch
*)
Function m047_read_digital_input_latched (micro_slot: byte): word;

(* Latch digital inputs
*)
Procedure m047_latch_digital_input (micro_slot: byte);

(* Set digital outputs
*)
Procedure m047_set_digital_output (micro_slot: byte; data: byte);

(* Read interrupt-vector-register
*)
Procedure m047_read_ivr (micro_slot: byte; var intnumber: byte; var overrun: byte);

(* Read interrupt-pending-register
*)
Function m047_read_ipr (micro_slot: byte): word;

(* Read interrupt-overrun-register
*)
Function m047_read_ior (micro_slot: byte): word;


implementation

{$IFNDEF Windows}           (* If no DLL is used, a .OBj file has to be included *)

{$L m047_lib.obj}

{$ENDIF}


(* Init module library
*)
Procedure m047_bib_startup (micro_slot: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Config module as defined in EEPROM
*)
Procedure m047_set_conf_eeprom (micro_slot: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Select interrupt line to base board
*)
Procedure m047_select_irq (micro_slot: byte; irqchannel: byte; irqedge: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Get selected interrupt line to base board
*)
Procedure m047_get_selected_irq (micro_slot: byte; var irqchannel: byte; var irqedge: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Mask/demask interrupt inputs
*)
Procedure m047_mask_interrupt (micro_slot: byte; intchannel: word);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Define edge of interrupt inputs
*)
Procedure m047_set_int_edge (micro_slot: byte; intedge: word);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Get masked interrupt inputs and corresponding edges
*)
Procedure m047_get_interrupt (micro_slot: byte; var intchannel: word; var intedge: word);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Define latch input
*)
Procedure m047_define_latch_input (micro_slot: byte; channel: byte; edge: byte; enable: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Get define latch input
*)
Procedure m047_get_latch_input (micro_slot: byte; var channel: byte; var edge: byte; var enable: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Define output function
*)
Procedure m047_define_output (micro_slot: byte; outputfunc: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Get defined output function
*)
Procedure m047_get_outputfunc (micro_slot: byte; var outputfunc: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Configure counter
*)
Procedure m047_counter_config (micro_slot: byte; var config: m047_config_struct);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Send command to counter
*)
Procedure m047_send_command (micro_slot: byte; command: word; counter: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Write word to counter
*)
Procedure m047_preset_counter_word (micro_slot: byte; counter: byte; data: word);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Write dword to counter
*)
Procedure m047_preset_counter_dword (micro_slot: byte; counter: byte; data: longint);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Write block to counter
*)
Procedure m047_preset_counter_block (micro_slot: byte; counter: byte; data: m047_block);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Read word from counter
*)
Function m047_read_counter_word (micro_slot: byte; counter: byte): word;
         external {$IFDEF Windows} M047DLL {$ENDIF};

(* Read double word from counter
*)
Function m047_read_counter_dword (micro_slot: byte; counter: byte): longint;
         external {$IFDEF Windows} M047DLL {$ENDIF};

(* Read block from counter
*)
Procedure m047_read_counter_block (micro_slot: byte; counter: byte; var data: m047_block);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Read status of counter
*)
Function m047_read_counter_status (micro_slot: byte; counter: byte): byte;
         external {$IFDEF Windows} M047DLL {$ENDIF};

(* Read digital inputs
*)
Function m047_read_digital_input (micro_slot: byte): word;
         external {$IFDEF Windows} M047DLL {$ENDIF};

(* Read digital inputs from latch
*)
Function m047_read_digital_input_latched (micro_slot: byte): word;
         external {$IFDEF Windows} M047DLL {$ENDIF};

(* Latch digital inputs
*)
Procedure m047_latch_digital_input (micro_slot: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Set digital outputs
*)
Procedure m047_set_digital_output (micro_slot: byte; data: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Read interrupt-vector-register
*)
Procedure m047_read_ivr (micro_slot: byte; var intnumber: byte; var overrun: byte);
          external {$IFDEF Windows} M047DLL {$ENDIF};

(* Read interrupt-pending-register
*)
Function m047_read_ipr (micro_slot: byte): word;
         external {$IFDEF Windows} M047DLL {$ENDIF};

(* Read interrupt-overrun-register
*)
Function m047_read_ior (micro_slot: byte): word;
         external {$IFDEF Windows} M047DLL {$ENDIF};

begin
end.